VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Const m_Syntax As String = "Borland Delphi"
Private Const m_Version As String = "3.00"

Private m_Expl_Const As Boolean
Private m_Insert_After_Option As Boolean
Private m_AutoFormat As Boolean
Private m_ShowParams As Boolean
Private m_Type As String
Public m_Charset As Long

Public Property Let Charset(mCharset)
    m_Charset = mCharset
End Property

Public Property Get VarRanges() As Boolean
    'VB supports Public/Private: set it to True
    VarRanges = True
End Property

Public Sub mNoRange()
    m_Type = ""
End Sub

Public Sub mPublic()
    m_Type = "Public "
End Sub

Public Sub mPrivate()
    m_Type = "Private "
End Sub

Public Property Get Version() As String
    Version = m_Version
End Property

Public Property Get Syntax() As String
    Syntax = m_Syntax
End Property

Public Function InitPlugIn() As Boolean
    'Return True if Init is successful
    InitPlugIn = True
End Function

Public Property Get ShowParams() As Boolean
    'Only needed for MASM
    ShowParams = False
End Property

Public Property Let ShowParams(m_Use_ShowParams As Boolean)
    m_ShowParams = m_Use_ShowParams
End Property

Public Property Get AutoFormat() As Boolean
    'Return True if the programming langauge
    'supports Declarations in more than one line
    AutoFormat = True
End Property

Public Property Let AutoFormat(m_Use_AutoFormat As Boolean)
    m_AutoFormat = m_Use_AutoFormat
End Property

Public Property Get ExplConst() As Boolean
    'Return True if the programming langauge
    'supports explicit declaration of
    'constants
    ExplConst = True
End Property

Public Property Let ExplConst(m_Use_Expl_Const As Boolean)
    m_Expl_Const = m_Use_Expl_Const
End Property

Public Property Get InsertAfterOption() As Boolean
    InsertAfterOption = False
End Property

Public Property Let InsertAfterOption(m_Use_Insert_After_Option As Boolean)
    m_Insert_After_Option = m_Use_Insert_After_Option
End Property

Public Function GetType(ByVal m_Name As String, ByVal m_Data As String) As String
    Dim mTemp As String
    mTemp = Replace(Replace(Replace(Replace(Replace(m_Data, "As Long", ": Integer"), "As Integer", ": Integer"), "As String", ": PChar"), " As", " :"), vbNewLine, ";" & vbNewLine)
    mTemp = d_Types(Left$(mTemp, Len(mTemp) - 1))
    GetType = d_Remarks("Type " & vbNewLine & m_Name & " = Record" & vbNewLine & mTemp & ";" & vbNewLine & "End;")
End Function

Public Function GetEnum(ByVal m_Name As String, ByVal m_Data As String) As String
    GetEnum = "Not Supported"
End Function

Public Function GetConst(m_Name As String, m_Data As String) As String
    GetConst = d_Remarks(GetDelphiConst(m_Name & " = " & m_Data & ";"))
End Function

Private Function d_Remarks(m_Text As String) As String
    Dim z As Integer
    Dim m_Tmp As Integer, h As Integer
    z = 1
    Do Until z = 0
        z = InStr(m_Text, "'")
        If z > 0 Then
            m_Tmp = z + 1 - InStrRev(m_Text, vbNewLine, z + 1)
            If m_Tmp <= 6 Then
                m_Text = Left$(m_Text, z - 2) & Chr(9) & "{" & Trim$(Right$(m_Text, Len(m_Text) - z))
            Else
                m_Text = Left$(m_Text, z - 2) & "; {" & Trim$(Right$(m_Text, Len(m_Text) - z))
            End If
            h = InStr(z, m_Text, vbNewLine)
            m_Text = Left$(m_Text, h - 2) & "}" & Right$(m_Text, Len(m_Text) - h + 1)
        End If
    Loop
    m_Text = Replace(m_Text, Chr(34), "'")
    m_Text = Replace(m_Text, "(", "[")
    m_Text = Replace(m_Text, ")", "]")
    m_Text = Replace(m_Text, vbNewLine & Chr(9) & ";" & vbNewLine, vbNewLine & vbNewLine)
    m_Text = Replace(m_Text, " To ", "..")
    d_Remarks = m_Text
End Function

Private Function GetDelphiConst(m_Text As String) As String
    Dim z As Integer
    m_Text = Replace(m_Text, "&H", "$")
    z = InStr(m_Text, "$")
    If z > 0 Then
        If Len(m_Text) - z < 8 Then
            m_Text = Left$(m_Text, z) & String(8 - (Len(m_Text) - z - 1), "0") & Right$(m_Text, Len(m_Text) - z)
        End If
    End If
    GetDelphiConst = m_Text
End Function

Private Function d_Types(m_Text As String) As String
    Dim z As Integer, h As Integer, g As Integer
    z = InStr(m_Text, "*")
    If z < 1 Then
        d_Types = m_Text
        Exit Function
    End If
    z = 1
    m_Text = Replace(m_Text, " * ", "[")
    Do
        z = InStr(z + 1, m_Text, "[")
        If z <= 0 Then Exit Do
        h = InStr(z, m_Text, ";")
        g = InStr(m_Text, "'")
        If g > 0 Then
            m_Text = RTrim$(Left$(m_Text, g - 1)) & "] '" & Right$(m_Text, Len(m_Text) - g)
            h = 0
        End If
        If h > 0 Then
            m_Text = Left$(m_Text, h - 1) & "];" & Right$(m_Text, Len(m_Text) - h)
        ElseIf h < 0 Then
            m_Text = m_Text & "]"
        End If
    Loop
    d_Types = m_Text
End Function

Public Function GetSub(m_Name As String, m_Data As String) As String
    GetSub = GetDelphiSyntax("procedure " & m_Name & " Lib " & Replace(Replace(Replace(Replace(m_Data, "&", " : Integer"), "%", " : Integer"), "?", "ByVal "), "~", "ByRef "))
End Function

Public Function GetFunc(m_Name As String, m_Data As String) As String
    GetFunc = GetDelphiSyntax("function " & m_Name & " Lib " & Replace(Replace(Replace(Replace(m_Data, "&", " : Integer"), "%", " : Integer"), "?", "ByVal "), "~", "ByRef "))
End Function

Private Function GetDelphiSyntax(m_Text As String) As String
    Dim z As Integer
    m_Text = Replace(m_Text, "ByVal", "")
    m_Text = Replace(m_Text, "ByRef", "")
    z% = InStr(LCase$(m_Text), " lib ") + 1
    m_Text = Replace(m_Text, "As Integer", " : Integer")
    m_Text = Replace(m_Text, "As String", " : PChar")
    m_Text = Replace(m_Text, "As Any", " : Pointer")
    m_Text = Replace(m_Text, "As Variant", " : OleVariant")
    m_Text = Left$(m_Text, z% - 1) & Right$(m_Text, Len(m_Text) - InStrRev(m_Text, Chr(34)))
    m_Text = Replace(m_Text, "  ", " ")
    m_Text = Replace(m_Text, "( ", "(")
    m_Text = Replace(m_Text, " As", " :")
    If m_AutoFormat Then
        m_Text = Replace(m_Text, ",", "," & vbNewLine & Chr(9)) & ";"
    End If
    GetDelphiSyntax = m_Text
End Function

Public Function Preview() As String
    Dim strTemp As String
    If m_Expl_Const Then
        strTemp = "Const Test As Long = 1" & vbNewLine & vbNewLine
    Else
        strTemp = "Const Test = 1" & vbNewLine & vbNewLine
    End If
    If m_AutoFormat Then
        strTemp = strTemp & "Declare Function Test Lib " & Chr(34) & "MyDLL" & Chr(34) & " ( _ " & vbNewLine & Chr(9) & "Param1 As String," & " _ " & vbNewLine & Chr(9) & "Param2 As String," & " _ " & vbNewLine & Chr(9) & "Param3 As String," & " _ " & vbNewLine & Chr(9) & "Param4 As String) As Long"
    Else
        strTemp = strTemp & "Declare Function Test Lib " & Chr(34) & "MyDLL" & Chr(34) & " (Param1 As String, Param2 As String, Param3 As String, Param4 As String) As Long"
    End If
    If m_Insert_After_Option Then
        strTemp = "Option Explicit" & vbNewLine & vbNewLine & strTemp
    End If
    Preview = strTemp
End Function
