VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Const m_Syntax As String = "PureBasic"
Private Const m_Version As String = "3.00"

Private m_Expl_Const As Boolean
Private m_Insert_After_Option As Boolean
Private m_ShowParams As Boolean
Private m_AutoFormat As Boolean
Private m_Type As String
Private m_StructType As String
Public m_Charset As Long

Public Property Let Charset(mCharset)
    m_Charset = mCharset
End Property

Public Property Get VarRanges() As Boolean
    'VB supports Public/Private: set it to True
    VarRanges = True
End Property

Public Sub mNoRange()
    m_Type = ""
End Sub

Public Sub mPublic()
    m_Type = "Public "
    m_StructType = m_Type
End Sub

Public Sub mPrivate()
    m_Type = "Private "
    m_StructType = m_Type
End Sub

Public Property Get Version() As String
    Version = m_Version
End Property

Public Property Get Syntax() As String
    Syntax = m_Syntax
End Property

Public Function InitPlugIn() As Boolean
    'Return True if Init is successful
    InitPlugIn = True
End Function

Public Property Get ShowParams() As Boolean
    'Only needed for MASM
    ShowParams = False
End Property

Public Property Let ShowParams(m_Use_ShowParams As Boolean)
    m_ShowParams = m_Use_ShowParams
End Property

Public Property Get AutoFormat() As Boolean
    'Return True if the programming langauge
    'supports Declarations in more than one line
    AutoFormat = True
End Property

Public Property Let AutoFormat(m_Use_AutoFormat As Boolean)
    m_AutoFormat = m_Use_AutoFormat
End Property

Public Property Get ExplConst() As Boolean
    'Return True if the programming langauge
    'supports explicit declaration of
    'constants
    ExplConst = False
End Property

Public Property Let ExplConst(m_Use_Expl_Const As Boolean)
    m_Expl_Const = m_Use_Expl_Const
End Property

Public Function GetEnum(ByVal m_Name As String, ByVal m_Data As String) As String
    GetEnum = "Not Supported"
End Function

Public Function GetType(ByVal m_Name As String, ByVal m_Data As String) As String
    Dim z As Long, h As Long, g As Long
    m_Data = Replace(Replace(m_Data, " As Long", ".l"), " As Integer", ".w")
    m_Data = Replace(Replace(m_Data, " As Byte", ".b"), " As String", ".s")
    m_Data = Replace(Replace(m_Data, " As Single", ".f"), " As Double", ".f")
    m_Data = Replace(m_Data, " As ", ".")
    z = 1
    m_Data = Replace(m_Data, " * ", "[")
    Do
        z = InStr(z + 1, m_Data, "[")
        If z <= 0 Then Exit Do
        h = InStr(z, m_Data, vbNewLine)
        g = InStr(m_Data, "'")
        If g > 0 Then
            m_Data = RTrim$(Left$(m_Data, g - 1)) & "] '" & Right$(m_Data, Len(m_Data) - g)
            h = 0
        End If
        If h > 0 Then
            m_Data = Left$(m_Data, h - 1) & "]" & vbNewLine & Right$(m_Data, Len(m_Data) - h)
        ElseIf h < 0 Then
            m_Data = m_Data & "]"
        End If
    Loop
    m_Data = Replace(m_Data, "'", ";")
    GetType = "Structure " & m_Name & vbNewLine & m_Data & vbNewLine & "EndStructure"
End Function

Public Function GetConst(m_Name As String, m_Data As String) As String
    Dim mBuffer As String
    If InStr(m_Data, Chr(34)) < InStr(m_Data, "'") Or (InStr(m_Data, Chr(34)) > 0 And InStr(m_Data, "'") < 1) Then
        mBuffer = "String constants are not supported in PureBasic"
    Else
        mBuffer = "#" & m_Name & " = " & m_Data
    End If
    mBuffer = Replace(mBuffer, "'", ";")
    mBuffer = Replace(mBuffer, "&H", "$")
    mBuffer = Replace(mBuffer, "$", "")
    GetConst = mBuffer
End Function

Public Function GetSub(m_Name As String, m_Data As String) As String
    GetSub = GetDec(m_Name, m_Data)
End Function

Private Function GetDec(m_Name As String, ByVal m_Data As String)
    Dim mBuffer As String, mDllName As String
    m_Data = Right$(m_Data, Len(m_Data) - 1)
    mDllName = Left$(m_Data, InStr(m_Data, Chr$(34)) - 1)
    If InStr(mDllName, ".") < 1 Then mDllName = mDllName & ".dll"
    m_Data = Right$(m_Data, Len(m_Data) - InStr(m_Data, Chr$(34)) - 1)
    If Right$(m_Data, 1) <> ")" Then m_Data = Left$(m_Data, Len(m_Data) - 1)
    m_Data = Replace(m_Data, " As Byte", ".b")
    m_Data = Replace(m_Data, " As Single", ".f")
    m_Data = Replace(m_Data, " As Double", ".f")
    m_Data = Replace(m_Data, "(", "")
    m_Data = Replace(m_Data, " As ", ".")
    m_Data = Replace(m_Data, ")", "")
    m_Data = Replace(m_Data, "&", ".l")
    m_Data = Replace(m_Data, "%", ".w")
    m_Data = Replace(m_Data, "$", ".s")
    m_Data = Replace(m_Data, "?", "")
    m_Data = Replace(m_Data, "~", "")
    mBuffer = "OpenLibrary(0," & Chr$(34) & mDllName & Chr$(34) & ")" & vbNewLine & "CallFunction(0," & Chr$(34) & m_Name & Chr$(34) & "," & m_Data & ")"
    GetDec = mBuffer
End Function

Public Function GetFunc(m_Name As String, m_Data As String) As String
    GetFunc = GetDec(m_Name, m_Data)
End Function

Public Property Let InsertAfterOption(m_Use_Insert_After_Option As Boolean)
    m_Insert_After_Option = m_Use_Insert_After_Option
End Property

Public Property Get InsertAfterOption() As Boolean
    InsertAfterOption = False
End Property

Private Function FormatDec(strText As String) As String
    Dim z As Integer
    Dim lStr As String, rStr As String
    If Not InStr(LCase$(strText), "declare") > 0 Then Exit Function
    If InStr(strText, "()") > 0 Or m_AutoFormat = False Then
        FormatDec = strText
        Exit Function
    End If
    z = InStr(strText, "(")
    lStr$ = Left$(strText, z)
    rStr$ = Right$(strText, Len(strText) - z)
    strText = lStr$ & " _ " & vbNewLine & Chr(9) & Space$(1) & rStr$
    FormatDec = Replace(strText, ",", ", _ " & vbNewLine & Chr(9))
End Function

Public Function Preview() As String
    Dim strTemp As String
    If m_Expl_Const = True Then
        strTemp = "Const Test As Integer = 1" & vbNewLine & vbNewLine
    Else
        strTemp = "Const Test = 1" & vbNewLine & vbNewLine
    End If
    If m_AutoFormat = True Then
        strTemp = strTemp & "Declare Function Test Lib " & Chr(34) & "MyDLL" & Chr(34) & " ( _ " & vbNewLine & Chr(9) & "Param1 As String," & " _ " & vbNewLine & Chr(9) & "Param2 As String," & " _ " & vbNewLine & Chr(9) & "Param3 As String," & " _ " & vbNewLine & Chr(9) & "Param4 As String) As Int32"
    Else
        strTemp = strTemp & "Declare Function Test Lib " & Chr(34) & "MyDLL" & Chr(34) & " (Param1 As String, Param2 As String, Param3 As String, Param4 As String) As Int32"
    End If
    Preview = strTemp
End Function
