VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Const m_Syntax As String = "Microsoft Visual Basic"
Private Const m_Version As String = "3.00"

Private m_Expl_Const As Boolean
Private m_Insert_After_Option As Boolean
Private m_AutoFormat As Boolean
Private m_ShowParams As Boolean
Private m_Type As String
Public m_Charset As Long

Public Property Let Charset(mCharset)
    m_Charset = mCharset
End Property

Public Property Get VarRanges() As Boolean
    'VB supports Public/Private: set it to True
    VarRanges = True
End Property

Public Sub mPublic()
    m_Type = "Public "
End Sub

Public Sub mNoRange()
    m_Type = ""
End Sub

Public Sub mPrivate()
    m_Type = "Private "
End Sub

Public Property Get Version() As String
    Version = m_Version
End Property

Public Property Get Syntax() As String
    Syntax = m_Syntax
End Property

Public Function InitPlugIn() As Boolean
    'Return True if Init is successful
    InitPlugIn = True
End Function

Public Property Get ShowParams() As Boolean
    'Only needed for MASM
    ShowParams = False
End Property

Public Property Let ShowParams(m_Use_ShowParams As Boolean)
    m_ShowParams = m_Use_ShowParams
End Property

Public Property Get AutoFormat() As Boolean
    'Return True if the programming langauge
    'supports Declarations in more than one line
    AutoFormat = True
End Property

Public Property Let AutoFormat(m_Use_AutoFormat As Boolean)
    m_AutoFormat = m_Use_AutoFormat
End Property

Public Property Get ExplConst() As Boolean
    'Return True if the programming langauge
    'supports explicit declaration of
    'constants
    ExplConst = True
End Property

Public Property Let ExplConst(m_Use_Expl_Const As Boolean)
    m_Expl_Const = m_Use_Expl_Const
End Property

Public Property Get InsertAfterOption() As Boolean
    InsertAfterOption = True
End Property

Public Property Let InsertAfterOption(m_Use_Insert_After_Option As Boolean)
    m_Insert_After_Option = m_Use_Insert_After_Option
End Property

Public Function GetType(ByVal m_Name As String, ByVal m_Data As String) As String
    Dim mBuffer As String
    mBuffer = m_Type & "Type " & m_Name & vbNewLine & m_Data & vbNewLine & "End Type"
    GetType = Replace(mBuffer, Chr$(13) & Chr$(13) & Chr$(10), vbNewLine)
End Function

Public Function GetEnum(ByVal m_Name As String, ByVal m_Data As String) As String
    Dim mBuffer As String
    mBuffer = m_Type & "Enum " & m_Name & vbNewLine & m_Data & vbNewLine & "End Enum"
    GetEnum = Replace(mBuffer, Chr$(13) & Chr$(13) & Chr$(10), vbNewLine)
End Function

Public Function GetConst(m_Name As String, m_Data As String) As String
    Dim m_Temp As String
    If m_Expl_Const Then
        If InStr(m_Data, Chr(34)) > 0 Then m_Temp = " As String" Else m_Temp = " As Long"
    Else
        m_Temp = ""
    End If
    GetConst = m_Type & "Const " & m_Name & m_Temp & " = " & m_Data
End Function

Public Function GetSub(m_Name As String, m_Data As String) As String
    Dim mBuffer As String
    Dim nPos As Long
    mBuffer = m_Type & FormatDec("Declare Sub " & m_Name & " Lib " & Replace(Replace(Replace(Replace(m_Data, "&", " As Long"), "%", " As Integer"), "?", "ByVal "), "~", "ByRef "))
    If InStr(mBuffer, ".") < 1 Then
        'add .dll
        nPos = InStr(mBuffer, Chr(34))
        nPos = InStr(nPos + 1, mBuffer, Chr(34))
        mBuffer = Left$(mBuffer, nPos - 1) & ".dll" & Right$(mBuffer, (Len(mBuffer) - nPos) + 1)
    End If
    If m_Charset = 1 Then
        mBuffer = Replace(mBuffer, "A" & Chr(34), "W" & Chr(34))
    Else
        mBuffer = Replace(mBuffer, "W" & Chr(34), "A" & Chr(34))
    End If
    GetSub = mBuffer
End Function

Public Function GetFunc(m_Name As String, m_Data As String) As String
    Dim mBuffer As String
    Dim nPos As Long
    mBuffer = m_Type & FormatDec("Declare Function " & m_Name & " Lib " & Replace(Replace(Replace(Replace(m_Data, "&", " As Long"), "%", " As Integer"), "?", "ByVal "), "~", "ByRef "))
    If InStr(mBuffer, ".") < 1 Then
        'add .dll
        nPos = InStr(mBuffer, Chr(34))
        nPos = InStr(nPos + 1, mBuffer, Chr(34))
        mBuffer = Left$(mBuffer, nPos - 1) & ".dll" & Right$(mBuffer, (Len(mBuffer) - nPos) + 1)
    End If
    If m_Charset = 1 Then
        mBuffer = Replace(mBuffer, "A" & Chr(34), "W" & Chr(34))
    Else
        mBuffer = Replace(mBuffer, "W" & Chr(34), "A" & Chr(34))
    End If
    GetFunc = mBuffer
End Function

Private Function FormatDec(strText As String) As String
    Dim z As Integer
    Dim lStr As String, rStr As String
    If Not InStr(LCase$(strText), "declare") > 0 Then Exit Function
    If InStr(strText, "()") > 0 Or m_AutoFormat = False Then
        FormatDec = strText
        Exit Function
    End If
    z = InStr(strText, "(")
    lStr$ = Left$(strText, z)
    rStr$ = Right$(strText, Len(strText) - z)
    strText = lStr$ & " _ " & vbNewLine & Chr(9) & Space$(1) & rStr$
    FormatDec = Replace(strText, ",", ", _ " & vbNewLine & Chr(9))
End Function

Public Function Preview() As String
    Dim strTemp As String
    If m_Expl_Const Then
        strTemp = "Const Test As Long = 1" & vbNewLine & vbNewLine
    Else
        strTemp = "Const Test = 1" & vbNewLine & vbNewLine
    End If
    If m_AutoFormat Then
        strTemp = strTemp & "Declare Function Test Lib " & Chr(34) & "MyDLL" & Chr(34) & " ( _ " & vbNewLine & Chr(9) & "Param1 As String," & " _ " & vbNewLine & Chr(9) & "Param2 As String," & " _ " & vbNewLine & Chr(9) & "Param3 As String," & " _ " & vbNewLine & Chr(9) & "Param4 As String) As Long"
    Else
        strTemp = strTemp & "Declare Function Test Lib " & Chr(34) & "MyDLL" & Chr(34) & " (Param1 As String, Param2 As String, Param3 As String, Param4 As String) As Long"
    End If
    If m_Insert_After_Option Then
        strTemp = "Option Explicit" & vbNewLine & vbNewLine & strTemp
    End If
    Preview = strTemp
End Function
